(function() {
  "use strict";
  angular.module("KAO.background", []).directive("background", function() {
    function link(scope, element, attrs, ngModel) {
      var head, style, shee, src, err, http, size, image, css;
      // 创建样式
      function pushClass(rules, selector) {
        selector = selector || randomClassName();
        if (rules == undefined) {
          return selector;
        }

        if (shee.insertRule) {
          shee.insertRule("." + selector + "{" + rules + "}", 0);
        } else if (shee.addRule) {
          shee.addRule("." + sselector, rules, 0);
        }
        return selector;
      }
      // 随机样式名称
      function randomClassName() {
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        var maxPos = chars.length;
        var str = "";
        for (var i = 0; i < 10; i++) {
          str += chars.charAt(Math.floor(Math.random() * (maxPos + 1)));
        }
        return str;
      }
      // 创建一个 style， 返回其 stylesheet 对象
      style = document.getElementsByTagName("style")[0];
      if (style == undefined) {
        head = document.head || document.getElementsByTagName("head")[0];
        style = document.createElement("style");
        style.type = "text/css";
        head.appendChild(style);
      }
      shee = style.sheet || style.styleSheet;

      src = scope.$parent.$eval(attrs.ngModel);
      err = scope.$parent.$eval(attrs.error);
      http = scope.$parent.$eval(attrs.http);
      size = scope.$parent.$eval(attrs.size);
      if (src.indexOf("http") == -1 && http != undefined) {
        src = http + src;
      }
      if (size == undefined) {
        size = "cover";
      }
      //創建圖片
      image = new Image();
      image.src = src;
      // 加載成功;
      image.onload = function() {
        addStyle(src);
      };
      // 加載失敗;
      image.onerror = function() {
        addStyle(err);
      };
      var addStyle = function(path) {
        css = "";
        css = css + "background-repeat:no-repeat;";
        css = css + "background-size:" + size + ";";
        css = css + "background-position:center;";
        css = css + "background-image:url(" + path + ");";
        angular.element(element).addClass(pushClass(css));
      };
    }
    return {
      restrict: "A",
      scope: {
        ngModel: "="
      },
      link: link
    };
  });
})();
